> module Algebra.Ideals where

Basic imports.

> import Data.List
> import Data.Maybe

Algebra imports.

> import Data.Ring
> import Data.Polynomial
> import Data.Monomial
> import Data.MonoidRing
> import Algebra.GroebnerBasis

Debugging imports

> import Debug.Trace

Computes the canonical residue mod an ideal

> mod_ideal :: (Fractional r, VarList m, Show m) => 
>              Polynom r m -> GroebnerIdeal r (Monom m) -> Polynom r m 
> mod_ideal p (MakeGroebnerIdeal i) 
>               | p == 0 = 0
>               | otherwise = normal_form (p,ltp) lti
>     where ltp = leading_term p
>           lti = [(s,leading_term s) | s <- i]

Checks whether an elemnt belongs to an ideal

> belongs_ideal :: (Fractional r, VarList m, Show m) => 
>                  Polynom r m -> GroebnerIdeal r (Monom m) -> Bool
> belongs_ideal p i = (p `mod_ideal` i) == 0

